<?php
/**
 * Plugin Charcode: inserts character with given unicode code
 * 
 * @license    GPL 2 (http://www.gnu.org/licenses/gpl.html)
 * @author     Vladimir Uryvaev <az@vovanium.ru>
 */
 
// must be run within DokuWiki
if(!defined('DOKU_INC')) die();
 
if(!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN',DOKU_INC.'lib/plugins/');
require_once(DOKU_PLUGIN.'syntax.php');
 
/**
 * All DokuWiki plugins to extend the parser/rendering mechanism
 * need to inherit from this class
 */
class syntax_plugin_charcode extends DokuWiki_Syntax_Plugin {
 
    function getInfo(){
      return array(
        'author' => 'Vladimir Uryvaev',
        'email'  => 'az@vovanium.ru',
        'date'   => '2009-04-10',
        'name'   => 'Charcode plugin',
        'desc'   => 'Inserts html-style character codes',
        'url'    => 'http://vovanium.ru/set/charcode',
      );
    }
 
    function getType() { return 'substition'; }
    function getSort() { return 32; }
    function connectTo($mode) { $this->Lexer->addSpecialPattern('&#?[0-9A-zZa-z]{2,8};',$mode,'plugin_charcode'); }
    function handle($match, $state, $pos, &$handler){ return array($match, $state, $pos); }
    function render($mode, &$renderer, $data) {
 
      if($mode == 'xhtml'){
          $renderer->doc .= $data[0];
          return true;
      }
      return false;
    }
}
?>